// <copyright file="UserDataConfiguration.cs" company="PlaceholderCompany">
// Copyright (c) PlaceholderCompany. All rights reserved.
// </copyright>

namespace Jellyfin.Database.Implementations.ModelConfiguration;

using System;
using Jellyfin.Database.Implementations.Entities;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Metadata.Builders;

/// <summary>
/// FluentAPI configuration for the UserData entity.
/// </summary>
public class UserDataConfiguration : IEntityTypeConfiguration<UserData>
{
    /// <inheritdoc/>
    public void Configure(EntityTypeBuilder<UserData> builder)
    {
        ArgumentNullException.ThrowIfNull(builder);
        builder.HasKey(d => new { d.ItemId, d.UserId, d.CustomDataKey });
        builder.HasIndex(d => new { d.ItemId, d.UserId, d.Played });
        builder.HasIndex(d => new { d.ItemId, d.UserId, d.PlaybackPositionTicks });
        builder.HasIndex(d => new { d.ItemId, d.UserId, d.IsFavorite });
        builder.HasIndex(d => new { d.ItemId, d.UserId, d.LastPlayedDate });
        builder.HasOne(e => e.Item).WithMany(e => e.UserData);
    }
}
